import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class SignalAdditionMultiplication800x600 extends PApplet {

/*
    SignalAdditionMultiplication800x600.pde
    Copyright (C) 2011
    Authors: Arun I, Hari Prasad Gokul R, Prabhu P, Sravan M Baddepudi, Sudhakar M K, Suresh Kannan M
    email: theroarofthedragon@gmail.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
*/

/* Program to illustrate the concepts of signal addition and multiplication
    Done as part of Signals and Systems Assignment, fourth semester, BE ECE
*/

PFont f;

DTDataPair input1,input2;

PlotAxes inputAxes1,inputAxes2,sumAxes,productAxes;

Button impulse1,step1,sine1,square1,exponential1,absolute1;
Button impulse2,step2,sine2,square2,exponential2,absolute2;
Button currentSignal1,currentSignal2;

SignalGenerator agilent;

public void setup()
{
  //initialize font
  f=loadFont("WenQuanYiMicroHeiMono-15.vlw");
  
  //initialize sketch
  size(800,550);
  background(255);
  smooth();
  
  //initialize plots, signal generator
  inputAxes1=new PlotAxes(200,50,180,180,f);
  inputAxes2=new PlotAxes(500,50,180,180,f);
  sumAxes=new PlotAxes(200,300,180,180,f);
  productAxes=new PlotAxes(500,300,180,180,f);
  agilent=new SignalGenerator();
  
  
  //initialize buttons for input signal 1
  impulse1=new Button(10,50,80,30,"Impulse",f);
  step1=new Button(10,100,80,30,"Step",f);
  sine1=new Button(10,150,80,30,"Sine",f);
  square1=new Button(10,200,80,30,"Square",f);
  exponential1=new Button(10,250,80,30,"Exp",f);
  absolute1=new Button(10,300,80,30,"Abs",f);
  
  //initialize buttons for input signal 2
  impulse2=new Button(710,50,80,30,"Impulse",f);
  step2=new Button(710,100,80,30,"Step",f);
  sine2=new Button(710,150,80,30,"Sine",f);
  square2=new Button(710,200,80,30,"Square",f);
  exponential2=new Button(710,250,80,30,"Exp",f);
  absolute2=new Button(710,300,80,30,"Abs",f);
  
  //set initial signal
  input1=agilent.unitImpulseSequence(-10,10);
  input2=agilent.unitImpulseSequence(-10,10);
  currentSignal1=impulse1;
  currentSignal2=impulse2;
  updateSignal1(impulse1);
  updateSignal2(impulse2);
  labelPlots();
}

public void draw()
{
}

public void mousePressed()
{
  //check for press of input signal 1 buttons
  if (impulse1.pressed())  updateSignal1(impulse1);
  else if (step1.pressed()) updateSignal1(step1);
  else if (sine1.pressed()) updateSignal1(sine1);
  else if (square1.pressed()) updateSignal1(square1);
  else if (exponential1.pressed()) updateSignal1(exponential1);
  else if (absolute1.pressed()) updateSignal1(absolute1);
  
  //check for press of input signal 2 buttons
  if (impulse2.pressed())  updateSignal2(impulse2);
  else if (step2.pressed()) updateSignal2(step2);
  else if (sine2.pressed()) updateSignal2(sine2);
  else if (square2.pressed()) updateSignal2(square2);
  else if (exponential2.pressed()) updateSignal2(exponential2);
  else if (absolute2.pressed()) updateSignal2(absolute2);
}

public void updateSignal1(Button newSignal)
{
  //unlock previously selected signal
  currentSignal1.locked=false;
  currentSignal1.update();
  
  //lock currently selected signal
  currentSignal1=newSignal;
  currentSignal1.locked=true;
  
  //generate the input signal
  if (newSignal==impulse1)  input1=agilent.unitImpulseSequence(-10,10);
  if (newSignal==step1)  input1=agilent.unitStepSequence(-10,10);
  if (newSignal==sine1)  input1=agilent.sineSequence(-10,10);
  if (newSignal==square1)  input1=agilent.squareSequence(-10,10,4);
  if (newSignal==exponential1)  input1=agilent.expSequence(-10,10);
  if (newSignal==absolute1) input1=agilent.absoluteSequence(-10,10);
  
  //display input and output signals
  currentSignal1.update();
  inputAxes1.stem(input1);
  addSignals();
  multiplySignals();
}

public void updateSignal2(Button newSignal)
{
  //unlock previously selected signal
  currentSignal2.locked=false;
  currentSignal2.update();
  
  //lock currently selected signal
  currentSignal2=newSignal;
  currentSignal2.locked=true;

  //generate the input signal
  if (newSignal==impulse2)  input2=agilent.unitImpulseSequence(-10,10);
  if (newSignal==step2)  input2=agilent.unitStepSequence(-10,10);
  if (newSignal==sine2)  input2=agilent.sineSequence(-10,10);
  if (newSignal==square2)  input2=agilent.squareSequence(-10,10,4);
  if (newSignal==exponential2)  input2=agilent.expSequence(-10,10);
  if (newSignal==absolute2) input2=agilent.absoluteSequence(-10,10);  

  //display input and output signals
  currentSignal2.update();
  inputAxes2.stem(input2);
  addSignals();
  multiplySignals();
}

public void addSignals()
{
  DTDataPair sum=new DTDataPair(new int[input1.n.length],new float[input1.n.length]);
  for (int i=0;i<=input1.n.length-1;i++)
  {
    sum.n[i]=input1.n[i];
    sum.x[i]=input1.x[i]+input2.x[i];
  }
  sumAxes.stem(sum);
}

public void multiplySignals()
{
  DTDataPair product=new DTDataPair(new int[input1.n.length],new float[input1.n.length]);
  for (int i=0;i<=input1.n.length-1;i++)
  {
    product.n[i]=input1.n[i];
    product.x[i]=input1.x[i]*input2.x[i];
  }
  productAxes.stem(product);
}

public void labelPlots()
{
  //clear label area
  noStroke();
  fill(255);
  rect(245,20,100,20);
  rect(540,20,100,20);
  rect(245,270,100,20);
  rect(540,270,100,20);
  
  //print labels
  fill(0);
  textAlign(CENTER,TOP);
  text("x[n]",295,25);
  text("y[n]",595,25);
  text("x[n]+y[n]",295,275);
  text("x[n].y[n]",595,275);
}
/*
    Button.pde
    Copyright (C) 2011
    Authors: Arun I, Hari Prasad Gokul R, Prabhu P, Sravan M Baddepudi, Sudhakar M K, Suresh Kannan M
    email: theroarofthedragon@gmail.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
*/

//class to create a rectangular button

class Button
{
  //Position and dimensions of the button
  int xPos,yPos;
  int widthButton,heightButton;
  
  //Button properties
  String label;
  boolean locked=false;
  
  //Appearance attributes
  int baseColor=color(0);
  int highlightColor=color(125);
  int currentColor=baseColor,textColor=color(255,0,0);
  PFont font;
  
  Button(int xPos_,int yPos_,int widthButton_,int heightButton_,String label_,PFont font_)
  {
    //Storing construction values for later reference
    xPos=xPos_;
    yPos=yPos_;
    widthButton=widthButton_;
    heightButton=heightButton_;
    label=label_;
    font=font_;
    
    //draw button on the sketch
    drawButton();
  }

  public void update() 
  {
    //set the color of the button according to locked status
    if (locked)
      currentColor = highlightColor;
    else
      currentColor = baseColor;
    //redraw button on the sketch
    drawButton();
  }

  public boolean pressed() 
  {
    //function checks if the button has been pressed
    if(over())
    {
      locked = !locked;
      return true;
    } 
    else
      return false;
  }

  public boolean over() 
  {
    //function checks if mouse is over the button
    if (mouseX >= xPos && mouseX <= xPos+widthButton && mouseY >= yPos && mouseY <= yPos+heightButton)
      return true; 
    else
      return false;
  }
  
  public void drawButton() 
  {
    //draw rectangle for the button
    stroke(255);
    fill(currentColor);
    rect(xPos,yPos,widthButton,heightButton);
    
    //print button label
    fill(textColor);
    textAlign(CENTER,CENTER);
    textFont(font,14);
    text(label,xPos+widthButton/2,yPos+heightButton/2);
  }
}
/*
    DTDataPair.pde
    Copyright (C) 2011
    Authors: Arun I, Hari Prasad Gokul R, Prabhu P, Sravan M Baddepudi, Sudhakar M K, Suresh Kannan M
    email: theroarofthedragon@gmail.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
*/

//class to hold an 'n' array and an 'x' array to represent a discrete time signal

class DTDataPair
{
  int[] n;
  float[] x;
  
  DTDataPair(int[] n_,float[] x_)
  {
    n=n_;
    x=x_;
  }
}
/*
    PlotAxes.pde
    Copyright (C) 2011
    Authors: Arun I, Hari Prasad Gokul R, Prabhu P, Sravan M Baddepudi, Sudhakar M K, Suresh Kannan M
    email: theroarofthedragon@gmail.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
*/

//class to plot an array using the stem plot

class PlotAxes
{
  //Position and dimensions of the plot
  int xPos,yPos;
  int widthPlot,heightPlot;
  
  //Data specifications
  float dataMin,dataMax;
  int nMin,nMax;
  
  //Scale and origin of the axes
  float T,scaleY;                    /* T - Processing distance per unit n;    scaleY - data range per unit Processing heightPlot  */
  int originX,originY;
  
  //Appearance attributes
  int backgroundColor,gridColor;
  int plotColor,flowerColor;
  PFont font;
  
  PlotAxes() {}
  
  PlotAxes(int xPos_,int yPos_,int widthPlot_,int heightPlot_,PFont font_)
  {
    //Storing construction values for later reference
    xPos=xPos_;
    yPos=yPos_;
    widthPlot=widthPlot_;
    heightPlot=heightPlot_;
    backgroundColor=color(255);
    gridColor=color(200,200,255);
    plotColor=color(255,0,0);
    flowerColor=color(255,255,0);
    font=font_;
    
    //Drawing the border of the plot on the sketch
    stroke(gridColor);
    fill(backgroundColor);
    rect(xPos,yPos,widthPlot,heightPlot);
  }
  
  public void stem(DTDataPair data)
  {
    //Drawing the border of the plot on the sketch
    noStroke();
    fill(backgroundColor);
    rect(xPos-100,yPos-10,widthPlot+120,heightPlot+40);
    stroke(gridColor);
    rect(xPos,yPos,widthPlot,heightPlot);
    
    //Storing data specifications for later reference
    if (data.x.length==0)  return;
    dataMin=min(data.x);
    dataMax=max(data.x);
    nMin=min(data.n);
    nMax=max(data.n);

    determineAxes();
    calibrateAxes();

    //Plot the given values 
    pushMatrix();
    translate(originX,originY);
    stroke(plotColor);
    float t;
    
    for (int i=0;i<=nMax-nMin;i++)
    {
      t=(nMin+i)*T;
      strokeWeight(2);
      line(t,0,t,-data.x[i]/scaleY);
      fill(flowerColor);
      ellipse(t,-data.x[i]/scaleY,6,6);
      strokeWeight(1);
    }
    popMatrix();
  }
  
  public void determineAxes()
  {
    //Determine X axis scale and origin
    float range=nMax-nMin;
    range= range==0?2:range;
      
    T=PApplet.parseFloat(widthPlot)/range;
    originX=xPos-PApplet.parseInt(nMin*T);
    
    //Determine Y axis scale and origin
    float dataMin_=dataMin<0?dataMin:0;
    float dataMax_=dataMax>0?dataMax:0;
    scaleY=(dataMax_-dataMin_)/heightPlot;
    scaleY=scaleY==0?2:scaleY;
    originY=yPos+heightPlot+PApplet.parseInt(dataMin_/scaleY);
  }
  
  public void calibrateAxes()
  {   
    calibrateXAxis();
    calibrateYAxis();
  }
  
  public void calibrateXAxis()
  {
    //Determine gapN and gapDistance
    int gapN=round(50/T);
    if (gapN==0) gapN=1;
    float gapDistance=gapN*T;
    
    //Calibrate the x axis
    pushMatrix();
    translate(originX,yPos+heightPlot);
    fill(0);
    textFont(font,14);
    textAlign(CENTER);

    for (int i=nMin/gapN;i<=nMax/gapN;i++)
    {
      stroke(0);
      line(i*gapDistance,5,i*gapDistance,0);
      text(i*gapN,i*gapDistance,20);
      stroke(gridColor);
      line(i*gapDistance,0,i*gapDistance,-heightPlot);
    }
    popMatrix();
  }
  
  public void calibrateYAxis()
  {
    //Determine gapData and gapHeight
    float gapData=50*scaleY;
    float gapHeight;
    int exponent=0;
    while (gapData<1)
    {
      gapData=gapData*10;
      exponent--;
    }
    while (gapData>=10)
    {
      gapData=gapData/10;
      exponent++;
    }
    gapData=round(gapData)*pow(10,exponent);
    gapHeight=gapData/scaleY;
    
    //Calibrate the y axis
    pushMatrix();
    translate(xPos,originY);
    fill(0);
    textFont(font,14);
    textAlign(RIGHT);
    
    float dataMin_=dataMin<0?dataMin:0;
    float dataMax_=dataMax>0?dataMax:0;
    for (int i=PApplet.parseInt(dataMin_/gapData);i<=dataMax_/gapData;i++)
    {
      stroke(0);
      line(-5,-i*gapHeight,0,-i*gapHeight);
      text(i*gapData,-8,-i*gapHeight);
      stroke(gridColor);
      line(0,-i*gapHeight,widthPlot,-i*gapHeight);
    }
  
    popMatrix();
  }
}
/*
    SignalGenerator.pde
    Copyright (C) 2011
    Authors: Arun I, Hari Prasad Gokul R, Prabhu P, Sravan M Baddepudi, Sudhakar M K, Suresh Kannan M
    email: theroarofthedragon@gmail.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
*/

//class to generate various discrete time input signals

class SignalGenerator
{
  SignalGenerator() {}
  
  public DTDataPair unitImpulseSequence(int nMin,int nMax)
  {
    int sizeOfArr=nMax-nMin+1;
    DTDataPair output=new DTDataPair(new int[sizeOfArr],new float[sizeOfArr]);
    for (int i=0;i<=sizeOfArr-1;i++)
    {
      output.n[i]=i+nMin;
      if (output.n[i]==0) output.x[i]=1;
      else output.x[i]=0;
    }
    return(output);
  }
  
  public DTDataPair unitStepSequence(int nMin,int nMax)
  {
    int sizeOfArr=nMax-nMin+1;
    DTDataPair output=new DTDataPair(new int[sizeOfArr],new float[sizeOfArr]);
    for (int i=0;i<=sizeOfArr-1;i++)
    {
      output.n[i]=i+nMin;
      if (output.n[i]>=0) output.x[i]=1;
      else output.x[i]=0;
    }
    return(output);
  }
  
  public DTDataPair unitRampSequence(int nMin,int nMax)
  {
    int sizeOfArr=nMax-nMin+1;
    DTDataPair output=new DTDataPair(new int[sizeOfArr],new float[sizeOfArr]);
    for (int i=0;i<=sizeOfArr-1;i++)
    {
      output.n[i]=i+nMin;
      if (output.n[i]>0) output.x[i]=output.n[i];
      else output.x[i]=0;
    }
    return(output);
  }
  
  public DTDataPair signumSequence(int nMin,int nMax)
  {
    int sizeOfArr=nMax-nMin+1;
    DTDataPair output=new DTDataPair(new int[sizeOfArr],new float[sizeOfArr]);
    for (int i=0;i<=sizeOfArr-1;i++)
    {
      output.n[i]=i+nMin;
      if (output.n[i]>0) output.x[i]=1;
      else if (output.n[i]<0) output.x[i]=-1;
      else output.x[i]=0;
    }
    return(output);
  }
  
  public DTDataPair sineSequence(int nMin,int nMax)
  {
    int sizeOfArr=nMax-nMin+1;
    DTDataPair output=new DTDataPair(new int[sizeOfArr],new float[sizeOfArr]);
    for (int i=0;i<=sizeOfArr-1;i++)
    {
      output.n[i]=i+nMin;
      output.x[i]=sin(output.n[i]);
    }
    return(output);
  }
  
  public DTDataPair squareSequence(int nMin,int nMax,int period)
  {
    int sizeOfArr=nMax-nMin+1;
    DTDataPair output=new DTDataPair(new int[sizeOfArr],new float[sizeOfArr]);
    for (int i=0;i<=sizeOfArr-1;i++)
    {
      output.n[i]=i+nMin;
      if (output.n[i]>=0) output.x[i]=abs(output.n[i]%period)<period/2?1:-1;
      else output.x[i]=abs((output.n[i]+1)%period)<period/2?-1:1;
    }
    return(output);
  }
  
  public DTDataPair sincSequence(int nMin,int nMax)
  {
    int sizeOfArr=nMax-nMin+1;
    DTDataPair output=new DTDataPair(new int[sizeOfArr],new float[sizeOfArr]);
    for (int i=0;i<=sizeOfArr-1;i++)
    {
      output.n[i]=i+nMin;
      if (output.n[i]==0) output.x[i]=1;
      else output.x[i]=sin(output.n[i]*PI)/(output.n[i]*PI);
    }
    return(output);
  }
  
  public DTDataPair expSequence(int nMin,int nMax)
  {
    int sizeOfArr=nMax-nMin+1;
    DTDataPair output=new DTDataPair(new int[sizeOfArr],new float[sizeOfArr]);
    for (int i=0;i<=sizeOfArr-1;i++)
    {
      output.n[i]=i+nMin;
      output.x[i]=exp(output.n[i]);
    }
    return(output);
  }
  
  public DTDataPair logSequence(int nMin,int nMax)
  {
    int sizeOfArr=nMax-nMin+1;
    DTDataPair output=new DTDataPair(new int[sizeOfArr],new float[sizeOfArr]);
    for (int i=0;i<=sizeOfArr-1;i++)
    {
      output.n[i]=i+nMin;
      output.x[i]=log(output.n[i]);
    }
    return(output);
  }
  
  public DTDataPair absoluteSequence(int nMin,int nMax)
  {
    int sizeOfArr=nMax-nMin+1;
    DTDataPair output=new DTDataPair(new int[sizeOfArr],new float[sizeOfArr]);
    for (int i=0;i<=sizeOfArr-1;i++)
    {
      output.n[i]=i+nMin;
      output.x[i]=abs(output.n[i]);
    }
    return(output);
  }
}
  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#DFDFDF", "SignalAdditionMultiplication800x600" });
  }
}
